# `naif` command line interface tools

- [`naif`](#naif) 
- [`naif test shell`](#naif-test-shell) 
- [`naif test telegram`](#naif-test-telegram)
- [`naif new dialog`](#naif-new-dialog) 
- [`naif show`](#naif-show) 

## `naif` 

```
$ naif
 _   _       _  __     _
| \ | |     (_)/ _|   | |
|  \| | __ _ _| |_    | |___
| . ` |/ _` | |  _|   | / __|
| |\  | (_| | | || |__| \__ \
|_| \_|\__,_|_|_| \____/|___/

NaifJs, simple state-machine based dialog manager
version: 0.41.12, author: giorgio.robino@gmail.com

Documentation:
/usr/local/lib/node_modules/naifjs/README.md

Examples:
/usr/local/lib/node_modules/naifjs/examples

Usage:

    naif test shell        command line dialog tester
    naif shell

    naif test telegram     telegram bot dialog tester
    naif telegram

    naif new app           create new project directory. SOON AVAILABLE!

    naif new unit          create dialog unit skeleton source code.

    naif show              show dialog units and states of a directory.

    naif help              show this help

``` 

## `naif show` 

command line dialog info

```
$ naif show
 _   _       _  __     _
| \ | |     (_)/ _|   | |
|  \| | __ _ _| |_    | |___
| . ` |/ _` | |  _|   | / __|
| |\  | (_| | | || |__| \__ \
|_| \_|\__,_|_|_| \____/|___/

simple state-machines based dialog manager sdk for nodejs developers
version: 0.37.0, author: giorgio.robino@gmail.com

Dialog Units Description

Usage:
    naif show

    --dir=<directory path>
      Dialog units directory path. Mandatory argument.


Examples:

   naif show --dir=./examples/myApplication

```


## `naif test shell` 

It's the command line dialog tester/debugger

```
$ naif test shell
 _   _       _  __     _
| \ | |     (_)/ _|   | |
|  \| | __ _ _| |_    | |___
| . ` |/ _` | |  _|   | / __|
| |\  | (_| | | || |__| \__ \
|_| \_|\__,_|_|_| \____/|___/

NaifJs, simple state-machine based dialog manager
version: 0.41.12, author: giorgio.robino@gmail.com

Command line dialog tester

Usage:

    naif shell
    naif test shell

    --dir=<directory path>
      Dialog units directory path. Mandatory

    --start=<unit.state>
      Initial dialog stateid in format "unit.state". Mandatory

    --id=<id>
      User id. Optional argument

    --logfile=<path/filename>
      Log filename with directory path. Optional

    --sessionsfile=<path/filename>
      Sessions filename with directory path. Optional

Examples:

   naif test --start=firstUnit.start --dir=examples/myDialogs

   naif test --dir=examples/app \
             --start=anotherUnit.showContents \
             --id=123456 \
             --logfile=examples/app/dialogs.log \
             --sessionsfile=examples/app/sessions.json

```


| ![naif test usage](img/naiftest.png) |
|:--:|
| figure 1: `naif test --dir=examples/story_it --start=firstUnit.dogIntroduction`.  |



## `naif test telegram` 

telegram bot to test a dialog, in a multiuser instant messaging environment.

```
$ naif test telegram
 _   _       _  __     _
| \ | |     (_)/ _|   | |
|  \| | __ _ _| |_    | |___
| . ` |/ _` | |  _|   | / __|
| |\  | (_| | | || |__| \__ \
|_| \_|\__,_|_|_| \____/|___/

NaifJs, simple state-machine based dialog manager
version: 0.41.12, author: giorgio.robino@gmail.com

Telegram bot (on-the fly server) dialog tester:
A single specified dialog run on the instant messaging app.
To test multimedia chat interaction, with multiple users at once.

Usage:

    naif test telegram
    naif telegram

    --token=<your telegram bot token id>
      Mandatory argument

    --dir=<directory path>
      Dialog units directory path. Mandatory

    --start=<unit.state>
      Initial dialog stateid in format "unit.state". Mandatory

    --chatids=<chatid1,chatid2,...>
      list of telegram chat ids (comma separated, no blanks). Optional

    --logfile=<path/filename>
      Log filename with directory path. Optional

    --sessionsfile=<path/filename>
      Sessions filename with directory path. Optional

Examples:

   naif telegram --token=YOUR_TELEGRAM_BOT_TOKEN \
                 --dir=examples/yourApp \
                 --start=yourDialogUnit.startState \
                 --chatids=123456789,923465768,228765452 \
                 --logfile=/dev/stdout \
                 --sessionsfile=yourApp/sessions.json

```


| ![naif telegram usage](img/naiftelegram.png) |
|:--:|
| figure 2: using `naif telegram`. On backgrond the terminal. On the right the telegram bot running a dialog |


## `naif new dialog` 

generate skeleton code for a new dialog.


```
 _   _       _  __     _
| \ | |     (_)/ _|   | |
|  \| | __ _ _| |_    | |___
| . ` |/ _` | |  _|   | / __|
| |\  | (_| | | || |__| \__ \
|_| \_|\__,_|_|_| \____/|___/

NaifJs, simple state-machine based dialog manager
version: 0.41.12, author: giorgio.robino@gmail.com

Create dialog unit skeleton source code

Usage:

    naif new dialog
    naif new unit

    --dir=<directory path>
      Dialog units directory path. Mandatory

    --unit=<unit name>
      Name of the dialog unit. Mandatory

    --desc=<description>
      Unit name description (for dialog user). Optional

    --outstates=<stateName1,stateName2,...>
      List of output state names, comma separated. Optional

    --instates=<stateName1:numPatterns1,stateName2:numPattern2,...>
      List of input state names, comma separated
      Each input state name is colon separated by a number of patterns. Mandatory

     -e
      end case in pattern. Mandatory argument

     -h
      help case in pattern. Mandatory argument

Examples:

   naif new --unit=myUnit --dir=tmp/dialogs/aDialog --instates=oneState:4

   naif new --unit=indovinalaparola \
            --dir=./examples/indovinalaparola \
            --desc="Indovina La Parola" \
            --outstates=start \
            --instates=input1:2,input2:3

```

---

[top](#) | [home](../README.md)
