const {say, next, exec, end, match, take} = require('../../')

//
// dialogs tag shortcuts
//
const restart = 'secondUnit.restart'
const dogIntroduction = 'firstUnit.dogIntroduction'

const secondUnit = {
  
  /**
   * askRestart
   * output state function
   */
  askRestart() {
    say('Do you want to restart?')
    next(restart)
  },

  /**
   * verifyName
   * input state function
   *
   * @param {requestDataObject} request
   *
   */
  restart(request) {

    switch(take(request)) {
       
      // yes
      case match( /^(yes|ok|true|right|correct|sure)/i ): 
         
        exec(dogIntroduction)
        break

      // no 
      case match( /^no/i ):
        
        // dialog end
        say('See you again!')
        end() 
        break
     
      // balblabla
      default:

        say('I do not understand.')
        say('Do you want to restart?')
        next(restart)
        break
    }
  }
}  

module.exports = secondUnit

